<template>
  <div>
    <b-button variant="danger" @click="resetModal = true">{{
      $t("deleteButton")
    }}</b-button>
    <coscine-modal
      v-model="resetModal"
      :title="$t('deleteModalHeadline')"
      :headerText="$t('deleteModalDescription')"
      :hideFooter="false"
      @confirmModal="handleSubmit"
    >
      <form ref="form" @submit.stop.prevent="handleSubmit">
        <b-form-group :state="deleteInputState">
          <div id="displayName">
            {{ this.displayName }}
          </div>
          <b-form-input
            id="delete_name_input"
            v-model="deleteName"
            :state="deleteInputState"
            required
            @change="disableHelp"
          ></b-form-input>
          <div class="invalid-tooltip" v-show="showHelp">
            {{ $t("deleteModalHelp") }}
          </div>
        </b-form-group>
      </form>
    </coscine-modal>
    <coscine-loading-spinner :isWaitingForResponse="isWaitingForResponse" />
  </div>
</template>

<script lang="ts">
import { FormGroupPlugin, BFormInput } from "bootstrap-vue";
import Vue from "vue";
Vue.use(FormGroupPlugin);
Vue.component("b-form-input", BFormInput);

import {
  CoscineLoadingSpinner,
  CoscineModal,
} from "@coscine/component-library";
import "@coscine/component-library/dist/index.css";
import { ProjectApi, SubProjectApi } from "@coscine/api-connection";

import VueI18n from "vue-i18n";
import { LinkUtil } from "@coscine/app-util";
Vue.use(VueI18n);

const i18n = new VueI18n({
  locale: "en",
  messages:
    window.coscine && window.coscine.i18n
      ? window.coscine.i18n["project-creation"]
      : undefined,
  silentFallbackWarn: true,
});

export default Vue.extend({
  i18n,
  name: "DeleteModal",
  components: {
    CoscineLoadingSpinner,
    CoscineModal,
  },
  data() {
    return {
      resetModal: false,
      deleteName: "",
      deleteInputState: null,
      showHelp: false,
      isWaitingForResponse: false,
    };
  },
  beforeMount() {
    i18n.locale = this.$props.languageLocale;
  },
  props: {
    languageLocale: {
      default: "en",
      type: String,
    },
    projectId: String,
    displayName: String,
  },
  // --- reset modal by changing visibility state (show/hide modal) ---
  watch: {
    resetModal() {
      this.deleteName = "";
      this.deleteInputState = null;
    },
  },
  methods: {
    checkFormValidity() {
      let valid = (this.$refs.form as any).checkValidity();
      if (this.deleteName !== this.displayName) {
        valid = false;
      }
      this.deleteInputState = valid;
      return valid;
    },
    disableHelp() {
      this.showHelp = false;
    },
    afterDeleteHandler(projectSlug = "") {
      if (projectSlug !== "") {
        LinkUtil.redirectToExternalProject(projectSlug);
      } else {
        LinkUtil.redirectToRoot();
      }
      this.isWaitingForResponse = false;
    },
    handleSubmit() {
      if (!this.checkFormValidity()) {
        this.showHelp = true;
        return;
      }
      this.isWaitingForResponse = true;
      SubProjectApi.getAccessibleParent(this.projectId, (response: any) => {
        const parentId = response.data.id;
        ProjectApi.getProjectInformation(
          parentId,
          (response: any) => {
            ProjectApi.deleteProject(
              this.projectId,
              (innerResponse: any) => {
                this.afterDeleteHandler(response.data.slug);
              },
              (innerErrorResponse: any) => {
                this.afterDeleteHandler(response.data.slug);
              }
            );
          },
          (error: any) => {
            ProjectApi.deleteProject(
              this.projectId,
              (innerResponse: any) => {
                this.afterDeleteHandler();
              },
              (innerErrorResponse: any) => {
                this.afterDeleteHandler();
              }
            );
          }
        );
      });
      this.resetModal = false;
    },
  },
});
</script>

<style>
.modal-header .modal-title {
  margin-block-start: 0;
  margin-block-end: 0;
  margin-left: 0;
}
.modal-header button.close {
  text-align: end;
  min-width: 1em;
}
.modal footer button {
  min-width: auto;
}
.modal-backdrop {
  opacity: 0.5;
}
.invalid-tooltip {
  margin-top: -5rem;
}
#displayName {
  font-size: large;
  padding-bottom: 0.3em;
}
</style>
